chiark / gitweb /
Use a proper makefile rather than the `setup' script.
[profile] / setup
diff --git a/setup b/setup
deleted file mode 100755 (executable)
index f7a0d9e..0000000
--- a/setup
+++ /dev/null
@@ -1,369 +0,0 @@
-#! /bin/bash
-
-set -e
-
-###--------------------------------------------------------------------------
-### Basic setup.
-
-umask 002
-
-sub=
-mkdir -p $HOME$sub
-
-: ${REPO=https://ftp.distorted.org.uk/pub/mdw/profile}
-
-export PATH=/usr/local/bin:$HOME$sub/bin:/usr/bin:/usr/ccs/bin:/bin
-
-###--------------------------------------------------------------------------
-### Sort out command line.
-
-xstuff= false=
-while [ $# -gt 0 ]; do
-  case "$1" in
-    -x) xstuff=t;;
-    -n) false=false;;
-    --) shift; break;;
-    -*) echo >&2 "$0: bad option"; exit 1;;
-    *) break;;
-  esac
-  shift
-done
-
-###--------------------------------------------------------------------------
-### Environment autoconfiguration.
-
-## Find out where I am
-here=$(pwd)
-
-## Suss out how to print things
-out=$(echo -n "foo"; echo "bar")
-if [ "$out" = "foobar" ]; then
-  echon="echo -n"
-  echoc=""
-else
-  echon="echo"
-  echoc='\c'
-fi
-
-## Find out how to fetch things over the net
-$echon "Finding URL fetcher:$echoc"
-if curl >/dev/null 2>&1 --version || [ $? -eq 2 ]; then
-  GETURL="curl -fs -o"
-  echo " curl."
-elif wget >/dev/null 2>&1 --version; then
-  GETURL="wget -q -O"
-  echo " wget."
-else
-  echo " failed!"
-  echo >&2 "$0: failed to find URL fetcher"
-  exit 1
-fi
-
-###--------------------------------------------------------------------------
-### Create the necessary directories.
-
-echo "Creating directories..."
-for i in bin lib/emacs src; do
-  $echon "  $i:$echoc"
-  if [ -d $HOME$sub/$i ]; then
-    echo " already exists."
-  else
-    mkdir -p $HOME$sub/$i
-    echo " done."
-  fi
-done
-echo " all done."
-
-###--------------------------------------------------------------------------
-### Install some more complicated programs.
-
-echo "Installing packages..."
-systems="
-  mlib:crc-mktab
-  checkpath:tmpdir
-"
-[ "$xstuff" ] && systems="$systems
-  xtoys:xatom
-"
-for system in $systems; do
-  set -- $(echo $system | tr : ' ')
-  sys=$1 prog=$2
-  $echon "  $sys:$echoc"
-  if $false $prog >/dev/null 2>&1 --version; then
-    echo " already installed."
-  else
-    ( set -e
-      $echon " downloading$echoc"
-      cd $HOME$sub/src
-      rm -rf $sys.tar.gz $sys-$ver
-      $GETURL $sys.tar.gz $REPO/$sys.tar.gz
-      $echon " unpacking$echoc"
-      dir=$(gzip -cd $sys.tar.gz | tar tf - | head -1)
-      gzip -cd $sys.tar.gz | tar xf -
-      $echon " configuring$echoc"
-      cd $dir
-      mkdir build
-      cd build
-      ../configure \
-       --prefix=$HOME$sub \
-       PKG_CONFIG_PATH=$HOME$sub/lib/pkgconfig \
-       >>buildlog 2>&1
-      $echon " building$echoc"
-      make >>buildlog 2>&1
-      $echon " installing$echoc"
-      make install >>buildlog 2>&1
-      echo " done."
-    )
-  fi
-done
-echo " all done."
-
-###--------------------------------------------------------------------------
-### Install global configuration.
-
-echo -n "Installing dotfile configuration:"
-if [ -f $HOME$sub/.mdw.conf ]; then
-  echo " already installed."
-else
-  cp mdw.conf $HOME$sub/.mdw.conf
-  echo " done."
-fi
-
-## Symlink the various dotfiles into place
-dotfiles="
-  profile shell-rc shell-logout
-  bash-profile:.bash_profile
-  bash-completion:.bash_completion bashrc inputrc
-  shrc
-  zprofile zshrc zshenv
-  emacs emacs-calc vm gnus.el ercrc.el
-  vimrc mg zile lesskey infokey sqliterc
-  parallel-config:.parallel/config
-  ipython-config.py:.ipython/profile_default/ipython_config.py
-  ipython-key-bindings.py:.ipython/profile_default/startup/50-key-bindings.py
-  ditz-config
-  mailrc signature muttrc
-  cgrc tigrc
-  gdbinit
-  guile
-  rcrc
-  toprc
-  mc-ini:.mc/ini mc-panels.ini:.mc/panels.ini
-  pulse-daemon.conf:.pulse/daemon.conf
-  aspell.conf
-  tclshrc:.tclshrc tclshrc:.wishrc
-  lisp-init.lisp:.cmucl-init.lisp
-    lisp-init.lisp:.sbclrc
-    lisp-init.lisp:.clisprc.lisp
-    lisp-init.lisp:.eclrc
-  swank.lisp
-  mdw-build.conf:.config/mdw-build.conf
-  w3m-config:.w3m/config elinks.conf:.elinks/elinks.conf
-  dircolors colordiffrc screenrc tmux.conf cvsrc indent.pro"
-[ "$xstuff" ] && dotfiles="$dotfiles
-  xinitrc xsession xmodmap vncrc vncsession
-  fonts.conf
-  stalonetrayrc
-  putty-defaults:.putty/sessions/Default%20Settings
-  mdw.session:.config/gnome-session/sessions/mdw.session
-  eterm-theme.cfg:.Eterm/themes/Eterm/theme.cfg
-  e-keybindings.cfg:.enlightenment/keybindings.cfg
-  evnc-keybindings.cfg:.enlightenment-vnc/keybindings.cfg
-  e16-bindings:.e16/bindings.cfg
-  gtkrc-2.0
-  gtk3.css:.config/gtk-3.0/gtk.css
-  gtk3-settings.ini:.config/gtk-3.0/settings.ini"
-echo "Installing dotfiles..."
-for d in $dotfiles; do
-  target=.$d
-  case $d in
-    *:*) target=${d#*:} d=${d%%:*};;
-  esac
-  ft=$HOME$sub/$target
-  dir=${ft%/*}
-  mkdir -p $dir
-  ln -s $here/dot/$d $ft.new
-  mv $ft.new $ft
-  echo "  $target"
-done
-echo " all done."
-
-## CPP-hack files which need it.
-cppfiles=""
-[ "$xstuff" ] && cppfiles="$cppfiles
-  Xdefaults"
-echo "Hacking files with C preprocessor..."
-defs="-DHOME=$HOME -DPROFILE=$here"
-defs="$defs -DEMACSWD=$(bin/mdw-conf emacs-width 77)"
-for c in $cppfiles; do
-  target=.$c
-  case $c in
-    *:*) target=${c#*:} c=${c%%:*};;
-  esac
-  ft=$HOME$sub/$target
-  dir=${ft%/*}
-  mkdir -p $dir
-  cpp -P $defs dot/$c -o $ft.new
-  mv $ft.new $ft
-  echo "  $target"
-done
-echo " all done."
-
-## Substitute things which need substituting.
-dotfilessubst="
-  gitconfig
-  mykermrc
-  pulse-default.pa.in:.pulse/default.pa"
-echo "Installing dotfiles with substitutions..."
-for d in $dotfilessubst; do
-  case $d in
-    *:*) target=${d#*:} d=${d%%:*};;
-    *) target=.$d d=$d.in;;
-  esac
-  ft=$HOME$sub/$target
-  dir=${ft%/*}
-  mkdir -p $dir
-  sed "
-1i\\
-### generated by $here/setup; do not edit!\\
-
-/@home@/ s\a\a$HOME\ag
-/@profile@/ s\a\a$here\ag
-/@releasekey@/ s\a\a$(bin/mdw-conf releasekey 481334C2)\ag
-" dot/$d >$ft.new
-  mv $ft.new $ft
-  echo "  $target"
-done
-echo "  all done."
-
-## Symlink backgrounds.
-backgrounds=$(cd bg && echo *)
-if [ "$xstuff" ]; then
-  echo "Installing backgrounds..."
-  for b in $backgrounds; do
-    for e in enlightenment e16; do
-      dir=$HOME$sub/.$e/backgrounds
-      t=$dir/$b
-      mkdir -p $dir
-      ln -s $here/bg/$b $t.new
-      mv $t.new $t
-    done
-    echo "  $b"
-  done
-  echo "       all done."
-fi
-
-###--------------------------------------------------------------------------
-### Install useful scripts included in this package.
-
-scripts="
-  mdw-editor
-  mdw-pager
-  mdw-conf
-  mdw-build mdw-sbuild mdw-sbuild-server
-  update-buildable-branch
-  emacsclient-hack
-  movemail-hack
-  sendmail-hack
-  aspell-hack
-  emerge-hack
-  lesspipe.sh
-  run-with-shell-env
-  start-ssh-agent
-  start-ssh-pageant
-  add-ssh-keys
-  svnwrap
-  guest-console
-  hyperspec"
-[ "$xstuff" ] && scripts="$scripts
-  xinitcmd
-  un-backslashify-selection
-  lock-screen
-  xpra-start-xdummy
-  xshutdown"
-echo "Installing scripts..."
-mkdir -p $HOME$sub/bin
-for s in $scripts; do
-  ft=$HOME$sub/bin/$s
-  ln -s $here/bin/$s $ft.new
-  mv $ft.new $ft
-  echo "  $s"
-done
-echo " all done."
-
-hacks="
-  ssh:ssh"
-echo "Installing hacks..."
-for h in $hacks; do
-  d=${h%%:*} h=${h#*:}
-  ft=$HOME$sub/bin/hacks/$d
-  mkdir -p $ft
-  ln -s $here/hacks/$h $ft/$h.new
-  mv $ft/$h.new $ft/$h
-  echo "  $d:$h"
-done
-echo " all done."
-
-###--------------------------------------------------------------------------
-### Set up the Emacs config.
-
-$echon "Finding a suitable emacs:$echoc"
-emacs=no
-for i in emacs24 emacs23 emacs22 emacs21 emacs; do
-  if type -p >/dev/null $i; then
-    emacs=$i
-    break
-  fi
-done
-if [ $emacs = no ]; then
-  echo " failed."
-  emacs=:
-else
-  echo " $emacs."
-fi
-
-echo "Installing Emacs packages..."
-emacspkg="
-  make-regexp
-  ew-hols
-  mdw-gnus-patch
-  git git-blame vc-git stgit
-  mdw-multiple-cursors
-  quilt"
-for elib in $emacspkg; do
-  $echon "  $elib:$echoc"
-  if $false $emacs >/dev/null 2>&1 --no-site-file --batch --eval '
-       (progn
-        (setq load-path (nconc load-path (list "~/lib/emacs")))
-        (kill-emacs (condition-case nil
-                        (progn (load-library "'"$elib"'") 0)
-                      (error 1))))'; then
-    echo " already installed."
-  else
-    if [ -f el/$elib.el ]; then
-      cp el/$elib.el $HOME$sub/lib/emacs/$elib.el
-    else
-      $echon " downloading$echoc"
-      $GETURL $HOME$sub/lib/emacs/$elib.el $REPO/$elib.el
-    fi
-    $echon " compiling$echoc"
-    (cd $HOME$sub/lib/emacs;
-      $emacs >/dev/null 2>&1 --no-site-file --batch \
-       --eval '(byte-compile-file "'"$elib.el"'")')
-    echo " done."
-  fi
-done
-echo " all done."
-
-$echon "Setting up Emacs configuration:$echoc"
-$echon " linking$echoc"
-for f in dot-emacs.el Makefile; do
-  set -- $(echo $link | tr : ' ')
-  ln -s $here/el/$f $HOME$sub/lib/emacs/$f.new
-  mv $HOME$sub/lib/emacs/$f.new $HOME$sub/lib/emacs/$f
-done
-$echon " compiling$echoc"
-{ cd $HOME$sub/lib/emacs && make EMACS=$emacs; } >/dev/null 2>&1
-echo " done."
-
-###----- That's all, folks --------------------------------------------------